!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Program for extraction of hourly vertical profiles from COSMO ...!!!
!!! Meteograms Files (Last Updated: DBS - May 01, 2016)              !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	Character(len=100) :: cyyyy, cmm, cdd, chhi, cbuffer, cstation,&
			      cfilename, chha

	d_r = 3.14159265359/180.0
	r_d = 180.0/3.14159265359

	Open (1, file = 'M_SHAR', form='formatted')

	Read (1, 10) cstation, cdd, cmm, cyyyy, chhi
 10	Format (19x, a3, /, 23x, a2, 1x, a2, 1x, a4, 2x, a2, 7(/))

	Do ihour = 1, 24

	ifilename = ihour + 10

	Read (1, 11) chha
 11	Format (66x, a4, 5(/))

	Read (chha, 12) ihha
 12	Format (i2)

	Print *, chha, ihha

	Write (cfilename, 13) cstation, cyyyy, cmm, cdd, chhi, ihha
 13	Format (a3, '-', a4, 3('-', a2), '+', i2.2, '.dat')

	Open (ifilename, file = cfilename, form = 'formatted')

	Write (ifilename, 14) 'K', 'PMAIN', 'T', 'QV', 'QC', 'QI', 'REL_HUM', &
			      'CLC', 'CLC_CON', 'U', 'V', 'SPEED', 'WD', 'HML'
 14	Format (30(1x, a10))

	Do ilev = 1, 50

 101	Continue
	Read (1, *, err=101, end=110) k, pmain, t, qv, qc, qi, rel_hum, clc, &
				      clc_con, u, v, speed, hml

	wd = (atan2(u,v) * r_d) + 180.0

	Write (ifilename, 15) k, pmain, t, qv, qc, qi, rel_hum, clc, &
                              clc_con, u, v, speed, wd, hml
 15	Format (1x, i10, 30(1x, f10.2))

	Enddo

	Read (1, 16)
 16	Format (87(/))

	Close(ifilename)

 110	Continue

	Enddo

	Stop

	End
